package crawling.entities;

import java.util.ArrayList;

public class AreaDescriptionEntity {
	
	private String mainName;
	private ArrayList<String> alterNames;
	
	
	public AreaDescriptionEntity() {
		alterNames = new ArrayList<String>(0);
	}
	public AreaDescriptionEntity(String mainName, ArrayList<String> alterNames) {
		this.mainName = mainName;
		this.alterNames = alterNames;
	}
	public ArrayList<String> getAlterNames() {
		return alterNames;
	}
	public void setAlterNames(ArrayList<String> alterNames) {
		this.alterNames = alterNames;
	}
	public String getMainName() {
		return mainName;
	}
	public void setMainName(String mainName) {
		this.mainName = mainName;
	}
	
	public String toString(){
		String text="MAIN NAME:"+mainName+"\n";
		if(alterNames!=null && alterNames.size()>0){
		for(String alterName:alterNames){
			text+="ALTERNATIVE NAME:"+alterName+" ";
		}
		text+="\n";
		}
		return text;
	}
}
