/**
 * class IdDescription
 * @author Dimitra Xidara
 */
package crawling.entities;

public class IdDescription {
	
	private int id;
	private String description;


	public IdDescription() {
	}
	
	
	public IdDescription(int id) {
		this.id = id;
	}

	public IdDescription(String description){
		this.description = description;
	}

	public IdDescription(int id, String description) {
		this.id = id;
		this.description = description;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	@Override
	public String toString() {
		return " ID:"+id+" DESCRIPTION:"+description;
	}
	
	public static boolean equals(IdDescription idDescr1, IdDescription idDescr2){
		if((idDescr1==null && idDescr2!=null) || (idDescr1!=null && idDescr2==null)){
			return false;
		}else if(idDescr1==null && idDescr2==null){
			return true;
		}else {
			if(idDescr2.getId() == idDescr1.getId()){
				return true;
			}
				return false;
		}
		
	}
	
}
