/****************************************
 * 			Syrgiannis Sotirios         *  
 ****************************************/
		package crawling.xe;

import java.sql.DriverManager;
import java.util.ArrayList;
import java.util.Properties;

import crawling.AnnKeywords;
import crawling.ReadSource;
import crawling.Utilities;
import crawling.database.DatabaseSelectManager;
import crawling.database.DatabaseUpdateManager;
import crawling.entities.Announcement;
import crawling.entities.HouseAnnouncement;
import crawling.entities.IdDescription;
import crawling.entities.SearchInfo;
import crawling.*;
public class Advertisments extends XEAdvertisments {
	
//********************************************************************************************************************
//Links Ta opoia Xrhsimopoiountai Gia thn Eksagwgh twn Aggeliwn
//********************************************************************************************************************
	public final static String Main_URL_XE = "http://www.xe.gr/pages/RealEstateCategories.aspx?catId=3";
	protected final static String Pattern="http://www.xe.gr/pages/";
	protected final static String Url_Start="<li><a href=\"";
	protected final static String Url_End="</a>";
	protected final static String Ann_start_tag="<br /> <a href=\"";
	protected final static String Ann_end_tag="</b></a>";
	protected final static String Annn_start_tag="<td width=\"105\" valign=\"top\"> <a href=\"";
	protected final static String Annn_end_tag="\"><img src=";
	protected final static String Ann_start_tag2="</td> <td valign=\"top\">";
	protected final static String Ann_end_tag2="</span></nobr>";
	protected final static String Adv_start_tag="e'))</script>";
	protected final static String Adv_end_tag="<br><br>";
					static String pages_start_tag;
					static String pages_end_tag="onclick=\"";
					static String Page="&CurrentPage=";
	//protected final static String Nomos_extraction_start_tag="<li>Ðåñéï÷Þ: <b>";
	protected final static String Nomos_extraction_start_tag="<li>Περιοχή: <b>";
	protected final static String Nomos_extraction_end_tag="</b></li>";
	protected final static String Nomos_extraction_start="<span class=\"path\"><a href=\"Index.aspx\">";
	protected final static String Nomos_extraction_end="</span>";
	  static int TypeOFAdv;
	  static int num_p=0;

//*********************************************************************************************************************	
	public Advertisments()
	{
		if(!openMySQLConnection()){
			System.out.println("FATAL ERROR!!!");
			System.exit(0);
		}
		else {
			editdatabase();	
		}		
	}
//************************************************************************************************************	
	protected  boolean openMySQLConnection() {
		try {
				Class.forName("com.mysql.jdbc.Driver");
			Properties props = new Properties();
			props.put("user", "root");
			props.put("password", "");
			props.put("useUnicode", "true");
			props.put("characterEncoding", "utf-8");
			connection = DriverManager.getConnection(
					"jdbc:mysql://localhost:3306/temp09062009", props);
			/*connection = DriverManager.getConnection(
					"jdbc:mysql://localhost/temp09062009", props);*/
			return true;
			
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println("ERROR: Failed to get connection to database!");
			return false;
		}
	}
	public void editdatabase()
	{		
String source,Mainsource;
String URL;		

int counter=0;
	ReadSource rSrc = new ReadSource(Main_URL_XE, AnnKeywords.XRYSH_EYKAIRIA);
    source =rSrc.getSource();
    System.out.println("\t \t \t **************************************************");
	System.out.println(" \t\t\t *\t\tStarting XE                       *");
	System.out.println("\t \t \t **************************************************");
	System.out.println("\n");
    ArrayList<String> urls= Utilities.extractAllTexts(source, Url_Start, Url_End);
  
    for(String url:urls){
    			num_p++;
        	   URL=Pattern+ url;   
        	   System.out.println("URL: "+URL);
        	   
        	   //********************************************************************
        	   //Methodos Gia Enoikiaseis kai Pwlhseis Akinhtwn
        	   //Gia to extraction twn aggeliwn.
        	   //editRent_Sell_Houses() Method
        	   //*********************************************************************
        	   if(URL.contains("Ενοικιάσεις Κατοικιών")||URL.contains("Ενοικιάσεις Επιπλωμένων")||URL.contains("Ενοικιάσεις Εξοχικών Κατοικιών")){
        		 TypeOFAdv=AnnKeywords.RENT_HOUSE_CODE;
        		 editRent_Sell_Houses(URL);
        		System.out.println("Finished Rent House Advertisments"); 
        	   }
        	if(URL.contains("Πωλήσεις Κατοικιών")||URL.contains("Πωλήσεις Εξοχικών Κατοικιών")){   
        	    TypeOFAdv=AnnKeywords.SELL_HOUSE_CODE;
        	    editRent_Sell_Houses(URL);
        	    System.out.println("Finished Sell House Advertisments"); 
        	  }
        	   //************************************************************************
        	   if (URL.contains("Πωλήσεις Οικοπέδων")){
        		   TypeOFAdv=AnnKeywords.SELL_EARTH_CODE;
        		   editSellEarth(URL);   
        		 System.out.println("Finished Sell Earth Advertisments");
        	   }
        	  // if(URL.contains("Πωλήσεις Κατοικιών")||URL.contains("Πωλήσεις Εξοχικών Κατοικιών")){
        	    if(URL.contains(AnnKeywords.PWLHSEIS_EKSWXIKWN_KATOIKIWN)){
        		 editEkswxika(URL);
        	   }   
    }
	}

//***********************************************************************************************************
	
//***************************************************************************************************
//Rent House Advertisments Extraction	
//***************************************************************************************************	
	/**
	 * @param URL
	 */
	private static void editRent_Sell_Houses(String URL){
		try{
		ArrayList<String> Nomos = null;
    	String finalurl="null";
    	String NOMOS = null;
    	String NOMO=null;
    	String Nomo=null;
		String url1 = URL.substring(0,URL.indexOf("\">"));
		System.out.println("url1: "+url1);
		//Thread t =new Thread();
		//t.start();
		ArrayList<String> advs= new ArrayList();
		ArrayList<String> links,ad;
		if (url1.contains("CategoriesLevel")){
			 links = extractAdvertisements(url1,Ann_start_tag,Ann_end_tag);
			 for(String l:links){
				 String l2;
				 l2 = l.substring(0,l.indexOf("\">"));
				 l2 = Pattern.concat(l2);
				 ad = extractAdvertisements(l,Ann_start_tag2,Ann_end_tag2);
				 advs.addAll(ad);
			 }
		}
		else{
			 advs = extractAdvertisements(url1,Ann_start_tag2,Ann_end_tag2);
		}
		System.out.println("Numero de anuncios: "+advs.size());
		advs = Utilities.getManyInOneAnnTexts(advs);
		Thread t=new Thread();
		t.start();
		int counter=0;
		
		for (String adv:advs){
			String temp= adv.substring(0,adv.indexOf("\">"));
			//System.out.println("ADV: "+adv);
			//System.out.println("TEMP: "+temp);
		    String url2=Pattern+temp;
            //url to opoio afora link me aggelies
//********************************************************************************************************************
//Epeksergasia ekastote Url wste na ginetai eksagwgh tou Arithmou Selidwn
//********************************************************************************************************************
			String tempurl=url2.substring(url2.indexOf("="),url2.length());
			pages_start_tag="<td width=\"11\" align=\"center\" valign=\"middle\"><a href=\"RealEstateResults.aspx?catId"+tempurl+"&CurrentPage=";			

//********************************************************************************************************************
			
//********************************************************************************************************************
//Eyresh Arithmou Selidwn pou periexoun aggelies
//********************************************************************************************************************	
			//insert try 
			ArrayList<String> No_pages=extractAdvertisements(url2,pages_start_tag,pages_end_tag);

			if (No_pages.size()!=0)
			{
				String pages=No_pages.get(1);
				pages=pages.substring(0,pages.indexOf("\""));
				int page = Integer.parseInt(pages);
				System.out.println("Number Of Pages ="+"\t"+page);
				//}
//**********************************************************************************************************************
			for(int i=1;i<=page;i++)
			{
			System.out.println("Page Number :    "+i + "  From  "+page+"\n");
			String Mainurl=url2+Page+i;
			System.out.println("  **** "+Mainurl+"  *****     ");
			//insert try
		    ArrayList<String> URLAdvs=extractAdvertisements(Mainurl,Annn_start_tag,Annn_end_tag);
		    System.out.println("Numero de URLAdvs "+URLAdvs.size());
			URLAdvs=Utilities.getManyInOneAnnTexts(URLAdvs);
//**********************************************************************************************************************
//Main Loop Sto opoio pragmatopoieitai h eksagwgh olwn twn Aggeliwn (olwn twn selidwn)
//To prwto Loop ekteleitai kai afora twn arithmo twn selidwn pou periexoun aggelies pou aforoun
//Mia Sygkekrimenh Perioxh
//Sthn Sunexeia Ta If xrhsimopoiountai gia thn afairesh kapoiwn TAGS ta opoia periexontai stis aggelies
//Kai den htan dunato na apaleipsw apo to arxiko extraction twn aggeliwn.
//Sthn Sunexeia mesa sto swma ths domhs IF xrhsimopoihsa tis katallhles methodous wste na ginetai 
//extraction  O nomos pou afora thn  kathe aggelia Xwrista wste na xrhsimopoihthie parakatw kata thn eisagwgh
//ths kathe aggelias sthn Apothikh Dedomenwn.		
//Epishs Ta Synexomena IF ta opoia sunantwntai ligo parakatw xrhsimopoiountai kai pali gia thn apaloifh
//kapoiwn anepithimitwn dedomenwn ta opoia den aforoun thn aggelia(text) alla einai kapoies alles
//plhrofories oi opoies me thn seira tous den mporesan na afairethoun kata to arxiko extraction
//(Dhladh eksagwgh aggeliwn apetheias apo to sourcecode).
//Sthn Sunexeia sto teleutaio emfwleumeno loop typwnwntai oi aggelies (plhroforia) sthn telikh tous
//pleon morfh exontas katharistei oi aggelies.			
//**********************************************************************************************************************
			for(String adv2:URLAdvs)
			{
				System.out.println("URLAdvs: "+adv2);
				if(adv2.contains("class=")){
				  System.out.println("Contains ");
				  String temp1=adv2.substring(0,adv2.indexOf("\""));    //&p eixe se parenthesh
				  //System.out.println("temp1: "+temp1);
				  finalurl=Pattern+temp1; 
				  //System.out.println("Final Url =   "+finalurl);
				  Nomos=extractAdvertisements(finalurl,Nomos_extraction_start_tag,Nomos_extraction_end_tag);
				  Nomos=Utilities.getManyInOneAnnTexts(Nomos);
				try{  
					NOMO=Nomos.get(0);
					}
				catch(Exception e){
					e.printStackTrace();
					System.out.println("Null");
				}
				  if (NOMO.contains("Íïì")){
					  Nomos=Utilities.getManyInOneAnnTexts(Nomos);
					 try{
						 NOMOS=Nomos.get(0);
						 }
					 catch(Exception e){
						 	e.printStackTrace();
							System.out.println("Null");
									}

					System.out.println("Ç Áããåëéá áíáöÝñåôáé óôïí ðáñáêÜôù íïìü: \t"+NOMOS);
					//	System.out.println(finalurl);
				  }
				  else 
				  {
					  Nomos=extractAdvertisements(finalurl,Nomos_extraction_start,Nomos_extraction_end);
					  Nomos=Utilities.getManyInOneAnnTexts(Nomos);
					  
			       try{
			    	   Nomo=Nomos.get(0);
			       }
		 		       catch(Exception e){
		 		    	  e.printStackTrace();
						System.out.println("Null");
								}
					  if (Nomo.contains("Èåóóáëïíßêç")){
						  System.out.println("Ç Áããåëéá áíáöÝñåôáé óôïí ðáñáêÜôù íïìü:\t Íïìüò Èåóóáëïíßêçò");
						  NOMOS="Íïìüò Èåóóáëïíßêçò";
					  }
					  if (Nomo.contains("ÁôôéêÞ")){
						  System.out.println("Ç Áããåëéá áíáöÝñåôáé óôïí ðáñáêÜôù íïìü:\t Íïìüò ÁôôéêÞò");
						  NOMOS="Íïìüò ÁôôéêÞò";
					 
					  }
				 }
				}
				else
				{ 
				finalurl=Pattern+adv2;
			    Nomos=extractAdvertisements(finalurl,Nomos_extraction_start_tag,Nomos_extraction_end_tag);
			    Nomos=Utilities.getManyInOneAnnTexts(Nomos);
				try{
					NOMO = Nomos.get(0);
					}
				catch(Exception e){
					e.printStackTrace();
					System.out.println("Null");
							}
			    if (NOMO.contains("Íïì")){
					  Nomos=Utilities.getManyInOneAnnTexts(Nomos);
					  try{ 
						  NOMOS=Nomos.get(0);
					  }catch(Exception e){
						  	e.printStackTrace();
							System.out.println("Null");
						}

					  System.out.println("Ç Áããåëéá áíáöÝñåôáé óôïí ðáñáêÜôù íïìü: \t"+NOMOS);
						//System.out.println(finalurl);
				  }
			    else
				  {
			    	 Nomos=extractAdvertisements(finalurl,Nomos_extraction_start,Nomos_extraction_end);
					 Nomos=Utilities.getManyInOneAnnTexts(Nomos);
					  
					try{ Nomo=Nomos.get(0);}
					catch(Exception e){
						e.printStackTrace();
						System.out.println("Null");
					                   }
			    	 if (Nomo.contains("Èåóóáëïíßêç")){
						  System.out.println("Ç Áããåëéá áíáöÝñåôáé óôïí ðáñáêÜôù íïìü:\t Íïìüò Èåóóáëïíßêçò");
						  NOMOS="Íïìüò Èåóóáëïíßêçò";
					  }
					  if (Nomo.contains("ÁôôéêÞ")){
						  System.out.println("Ç Áããåëéá áíáöÝñåôáé óôïí ðáñáêÜôù íïìü:\t Íïìüò ÁôôéêÞò");
						  NOMOS="Íïìüò ÁôôéêÞò";
					 
					  }
				  }
				}

				try{
					
					ArrayList<String> MainAdvs=extractAdvertisements(finalurl,Adv_start_tag,Adv_end_tag);
					MainAdvs=Utilities.getManyInOneAnnTexts(MainAdvs);
				
		
			if(MainAdvs.size()==3){
					MainAdvs.remove(1);
					MainAdvs.remove(1);
				}
				if(MainAdvs.size()==2){
				MainAdvs.remove(1);
				}
				if(MainAdvs.size()==4){
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					}
				if(MainAdvs.size()==5){
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					}
				if(MainAdvs.size()==6){
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					}
				if(MainAdvs.size()==7){
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					}
				//**************************************************************************
				//Creating The SearchInfo Object
				//**************************************************************************
				SearchInfo searchInfo= new SearchInfo();
				
				if(TypeOFAdv==AnnKeywords.RENT_HOUSE_CODE){
					searchInfo.setOffer(1);
				}
				if(TypeOFAdv==AnnKeywords.SELL_HOUSE_CODE){
					searchInfo.setSold(true);
				}
				searchInfo.setCategory(new IdDescription(TypeOFAdv));
				searchInfo.setSourceId(AnnKeywords.XRYSH_EYKAIRIA);
				searchInfo.setDate(new java.sql.Date(System.currentTimeMillis()));
				int nomosId=DatabaseSelectManager.getNomosId(NOMOS, connection);
				System.out.println("NOMOS ID=  "+nomosId);
				searchInfo.setNomos(new IdDescription(nomosId));
				searchInfo.setSearchId(DatabaseUpdateManager.updateSearchTable(searchInfo,connection));
				//System.out.println(MainAdvs.size());
				for(String finaladv:MainAdvs){
				 //String temp2=finaladv.substring(0,finaladv.indexOf("<br>"));
				if(finaladv.contains("<"))
				{
				finaladv=finaladv.substring(0,finaladv.indexOf("<"));	
				}    //************************************************************************** 
	                //Extract The Features Of Current Advertisment			
				   //****************************************************************************
				
				   try
				   {
					HouseFeatExtr house =new HouseFeatExtr(nomosId,finaladv,connection);
					System.out.println("House_Advertisment : "+finaladv+"     ");
					System.out.println(house.getAnnFeatures());
					HouseAnnouncement annFeatures = house.getAnnFeatures();
					annFeatures.setRent(true);
					//System.out.println(annFeatures);
					DatabaseUpdateManager.updateHouseAnnTable(new Announcement(), annFeatures,
								searchInfo.getSearchId(), AnnKeywords.SELL_HOUSE_CODE, connection);
					}
				   catch(Exception e)
				   {
					   e.printStackTrace();
					   System.out.println("Wrong in House Feat Extraction");
					  
				   }
			
				
				  
				   
				}
				}catch(Exception e)
				{
					e.printStackTrace();
					System.out.println("Wrong Extraction");
				}
					System.out.println("UPDATING ann_house TABLE...");
					counter++;
//**********************************************************************************************************************					
//Sto shmeio auto exei ginei extract to text ths aggelias kai tha ginei epeksergasia ths 
//wste na eisaxthei sthn vash dedomenwn					
//**********************************************************************************************************************					
//**********************************************************************************************************************
		/*try {
				t.sleep(18000);
				t.interrupt();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			    } */
		    }
			//System.out.println(adv2);	
		  }
		 }
			else {
				System.out.println("No Advertisments");
			}
			System.out.println(counter);
		}
		//MainAdvs=Utilities.getM
		
		
		
	 }catch(Exception e){
		  e.printStackTrace();
		  System.out.println("wrong");
	  }
	}
//**********************************************************************************************************************
	
//**********************************************************************************************************************
//**********************************************************************************************************************
	
	
	
  /**
 * @param URL
 */
private static void editSellEarth(String URL){
try{
	  ArrayList<String> Nomos = null;
  	String finalurl="null";
  	String NOMOS = null;
  	String NOMO=null;
  	String Nomo=null;
		String url1 = URL.substring(0,URL.indexOf("\">"));
		//Thread t =new Thread();
		//t.start();
		ArrayList<String> advs= new ArrayList();
		ArrayList<String> links,ad;
		if (url1.contains("CategoriesLevel")){
			 links = extractAdvertisements(url1,Ann_start_tag,Ann_end_tag);
			 for(String l:links){
				 String l2;
				 l2 = l.substring(0,l.indexOf("\">"));
				 l2 = Pattern.concat(l2);
				 ad = extractAdvertisements(l,Ann_start_tag2,Ann_end_tag2);
				 advs.addAll(ad);
			 }
		}
		else{
			 advs = extractAdvertisements(url1,Ann_start_tag2,Ann_end_tag2);
		}
		advs = Utilities.getManyInOneAnnTexts(advs);
		Thread t=new Thread();
		t.start();
		int counter=0;
		for (String adv:advs){
			String temp= adv.substring(0,adv.indexOf("\">"));
			//System.out.println("ADV: "+adv);
			//System.out.println("TEMP: "+temp);
		    String url2=Pattern+temp;
          //url to opoio afora link me aggelies
//********************************************************************************************************************
//Epeksergasia ekastote Url wste na ginetai eksagwgh tou Arithmou Selidwn
//********************************************************************************************************************
			String tempurl=url2.substring(url2.indexOf("="),url2.length());
			pages_start_tag="<td width=\"11\" align=\"center\" valign=\"middle\"><a href=\"RealEstateResults.aspx?catId"+tempurl+"&CurrentPage=";			
			//System.out.println(url2);
//********************************************************************************************************************
			
//********************************************************************************************************************
//Eyresh Arithmou Selidwn pou periexoun aggelies
//********************************************************************************************************************	
			ArrayList<String> No_pages=extractAdvertisements(url2,pages_start_tag,pages_end_tag);

			if (No_pages.size()!=0)
			{
				String pages=No_pages.get(1);
				pages=pages.substring(0,pages.indexOf("\""));
				int page = Integer.parseInt(pages);
				System.out.println("Number Of Pages ="+"\t"+page);
				//}
//**********************************************************************************************************************
			for(int i=1;i<=page;i++)
			{
			System.out.println("Page Number :    "+i + "  From  "+page+"\n");
			String Mainurl=url2+Page+i;
			System.out.println("  **** "+Mainurl+"  *****     ");
		    ArrayList<String> URLAdvs=extractAdvertisements(Mainurl,Annn_start_tag,Annn_end_tag);
		    System.out.println("Numero de anuncios: "+URLAdvs.size());
			URLAdvs=Utilities.getManyInOneAnnTexts(URLAdvs);
//**********************************************************************************************************************
//Main Loop Sto opoio pragmatopoieitai h eksagwgh olwn twn Aggeliwn (olwn twn selidwn)
//To prwto Loop ekteleitai kai afora twn arithmo twn selidwn pou periexoun aggelies pou aforoun
//Mia Sygkekrimenh Perioxh
//Sthn Sunexeia Ta If xrhsimopoiountai gia thn afairesh kapoiwn TAGS ta opoia periexontai stis aggelies
//Kai den htan dunato na apaleipsw apo to arxiko extraction twn aggeliwn.
//Sthn Sunexeia mesa sto swma ths domhs IF xrhsimopoihsa tis katallhles methodous wste na ginetai 
//extraction  O nomos pou afora thn  kathe aggelia Xwrista wste na xrhsimopoihthie parakatw kata thn eisagwgh
//ths kathe aggelias sthn Apothikh Dedomenwn.		
//Epishs Ta Synexomena IF ta opoia sunantwntai ligo parakatw xrhsimopoiountai kai pali gia thn apaloifh
//kapoiwn anepithimitwn dedomenwn ta opoia den aforoun thn aggelia(text) alla einai kapoies alles
//plhrofories oi opoies me thn seira tous den mporesan na afairethoun kata to arxiko extraction
//(Dhladh eksagwgh aggeliwn apetheias apo to sourcecode).
//Sthn Sunexeia sto teleutaio emfwleumeno loop typwnwntai oi aggelies (plhroforia) sthn telikh tous
//pleon morfh exontas katharistei oi aggelies.			
//**********************************************************************************************************************
			for(String adv2:URLAdvs)
			{
				
				if(adv2.contains("class=")){
				  System.out.println("Contains ");
				  String temp1=adv2.substring(0,adv2.indexOf("\""));    //&p eixe se parenthesh
				  //System.out.println("TEMP1: "+temp1);
				  finalurl=Pattern+temp1; 
				  //System.out.println("Final Url =   "+finalurl);
				 try{ Nomos=extractAdvertisements(finalurl,Nomos_extraction_start_tag,Nomos_extraction_end_tag);
				    Nomos=Utilities.getManyInOneAnnTexts(Nomos);}
				 catch(Exception e)
				 {
					 e.printStackTrace();
					 System.out.println("Wrong");
				 }
				try{  
					NOMO=Nomos.get(0);
					}
				catch(Exception e){
					e.printStackTrace();
					System.out.println("Null");
				}
				  if (NOMO.contains("Íïì")){
					  Nomos=Utilities.getManyInOneAnnTexts(Nomos);
					 try{
						 NOMOS=Nomos.get(0);
						 }
					 catch(Exception e){
						 	e.printStackTrace();
							System.out.println("Null");
									}

					System.out.println("Ç Áããåëéá áíáöÝñåôáé óôïí ðáñáêÜôù íïìü: \t"+NOMOS);
					//	System.out.println(finalurl);
				  }
				  else 
				  {
					  Nomos=extractAdvertisements(finalurl,Nomos_extraction_start,Nomos_extraction_end);
					  Nomos=Utilities.getManyInOneAnnTexts(Nomos);
					  
			       try{
			    	   Nomo=Nomos.get(0);
			       }
		 		       catch(Exception e){
		 		    	  e.printStackTrace();
						System.out.println("Null");
								}
					  if (Nomo.contains("Èåóóáëïíßêç")){
						  System.out.println("Ç Áããåëéá áíáöÝñåôáé óôïí ðáñáêÜôù íïìü:\t Íïìüò Èåóóáëïíßêçò");
						  NOMOS="Íïìüò Èåóóáëïíßêçò";
					  }
					  if (Nomo.contains("ÁôôéêÞ")){
						  System.out.println("Ç Áããåëéá áíáöÝñåôáé óôïí ðáñáêÜôù íïìü:\t Íïìüò ÁôôéêÞò");
						  NOMOS="Íïìüò ÁôôéêÞò";
					 
					  }
				 }
				}
				else
				{ 
				try{finalurl=Pattern+adv2;
			    Nomos=extractAdvertisements(finalurl,Nomos_extraction_start_tag,Nomos_extraction_end_tag);
			    Nomos=Utilities.getManyInOneAnnTexts(Nomos);
				
				}
				catch(Exception e)
				{
					e.printStackTrace();
					System.out.println("Wrong");
				}
					try{
				
					NOMO = Nomos.get(0);
					}
				catch(Exception e){
					e.printStackTrace();
					System.out.println("Null");
							}
			    if (NOMO.contains("Íïì")){
					  Nomos=Utilities.getManyInOneAnnTexts(Nomos);
					  try{ 
						  NOMOS=Nomos.get(0);
					  }catch(Exception e){
						  e.printStackTrace();
							System.out.println("Null");
						}

					  System.out.println("Ç Áããåëéá áíáöÝñåôáé óôïí ðáñáêÜôù íïìü: \t"+NOMOS);
						//System.out.println(finalurl);
				  }
			    else
				  {
			    	//insert try
			    	 Nomos=extractAdvertisements(finalurl,Nomos_extraction_start,Nomos_extraction_end);
					 Nomos=Utilities.getManyInOneAnnTexts(Nomos);
					  
					try{ Nomo=Nomos.get(0);}
					catch(Exception e){
						e.printStackTrace();
						System.out.println("Null");
					                   }
			    	 if (Nomo.contains("Èåóóáëïíßêç")){
						  System.out.println("Ç Áããåëéá áíáöÝñåôáé óôïí ðáñáêÜôù íïìü:\t Íïìüò Èåóóáëïíßêçò");
						  NOMOS="Íïìüò Èåóóáëïíßêçò";
					  }
					  if (Nomo.contains("ÁôôéêÞ")){
						  System.out.println("Ç Áããåëéá áíáöÝñåôáé óôïí ðáñáêÜôù íïìü:\t Íïìüò ÁôôéêÞò");
						  NOMOS="Íïìüò ÁôôéêÞò";
					 
					  }
				  }
				}

				
				try{
					ArrayList<String> MainAdvs=extractAdvertisements(finalurl,Adv_start_tag,Adv_end_tag);
				
				MainAdvs=Utilities.getManyInOneAnnTexts(MainAdvs);
              //NOMOS=NOMOS;
				if(MainAdvs.size()==3){
					MainAdvs.remove(1);
					MainAdvs.remove(1);
				}
				if(MainAdvs.size()==2){
				MainAdvs.remove(1);
				}
				if(MainAdvs.size()==4){
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					}
				if(MainAdvs.size()==5){
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					}
				if(MainAdvs.size()==6){
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					}
				if(MainAdvs.size()==7){
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					MainAdvs.remove(1);
					}
				//**************************************************************************
				//Creating The SearchInfo Object
				//**************************************************************************
				SearchInfo searchInfo= new SearchInfo();
				searchInfo.setSold(false);
				searchInfo.setOffer(1);
				searchInfo.setCategory(new IdDescription(TypeOFAdv));
				searchInfo.setSourceId(AnnKeywords.XRYSH_EYKAIRIA);
				searchInfo.setDate(new java.sql.Date(System.currentTimeMillis()));
				int nomosId=DatabaseSelectManager.getNomosId(NOMOS, connection);
				System.out.println("NOMOS ID=  "+nomosId);
				searchInfo.setNomos(new IdDescription(nomosId));
				searchInfo.setSearchId(DatabaseUpdateManager.updateSearchTable(searchInfo,connection));
				//System.out.println(MainAdvs.size());
				for(String finaladv:MainAdvs){
				 //String temp2=finaladv.substring(0,finaladv.indexOf("<br>"));
				if(finaladv.contains("<"))
				{
				finaladv=finaladv.substring(0,finaladv.indexOf("<"));	
				}    //************************************************************************** 
	                //Extract The Features Of Current Advertisment			
				   //****************************************************************************
				
				   try
				   {     
					    System.out.println("EXTRACTING FEATURES OF ANNOUNCEMENT...");
						SellEarthFeatExtr anFE = new SellEarthFeatExtr(nomosId, finaladv
								, connection);
						System.out.println("SellEarth_Advertisment : "+finaladv+"     ");
						System.out.println("UPDATING ann_sell_earth TABLE...");
						DatabaseUpdateManager.updateSellEarthAnnTable(new Announcement(), anFE
								.getAnnFeatures(), searchInfo.getSearchId() , connection);
				   }
				   catch(Exception e)
				   {
					   e.printStackTrace();
					   System.out.println("Wrong in Sell Earth Feat Extraction");
					  
				   }
			
				
				  
				   
				}
			}catch(Exception e)
			{
				e.printStackTrace();
				System.out.println("Wrong Extraction");
			}
					System.out.println("Update House Feat extraction");
					counter++;
//**********************************************************************************************************************					
//Sto shmeio auto exei ginei extract to text ths aggelias kai tha ginei epeksergasia ths 
//wste na eisaxthei sthn vash dedomenwn					
//**********************************************************************************************************************					
//**********************************************************************************************************************
		/*try {
				t.sleep(18000);
				t.interrupt();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			    } */
		    }
			//System.out.println(adv2);	
		  }
		 }
			else {
				System.out.println("No Advertisments");
			}
			System.out.println(counter);
		}
		//MainAdvs=Utilities.getM

		
}catch(Exception e){
	  e.printStackTrace();
	  System.out.println("Wrong");
}
		
		
}
  private static void editEkswxika(String URL){
	  String url1 = URL.substring(0,URL.indexOf("\">"));

}
  private static ArrayList<String> extractAdvertisements(String url,String Ann_start_tag,String Ann_end_tag){
	ReadSource readSource = new ReadSource(url,AnnKeywords.XRYSH_EYKAIRIA);
    String source = readSource.getSource();
	ArrayList<String> advertisements = Utilities.extractAllTexts(source,Ann_start_tag,Ann_end_tag);
	for(String adv:advertisements){
		System.out.println("ADV:"+adv);
	}
	return advertisements;
}
  
  public static void main(String[] args) {
	  Advertisments advs1 = new Advertisments();	

  }
}
