/****************************************
 * 			Syrgiannis Sotirios         *  
 ****************************************/

package crawling.xe;

import java.sql.Connection;
import java.sql.Date;
import java.sql.DriverManager;
import java.util.ArrayList;
import java.util.Properties;

import crawling.AnnKeywords;
import crawling.ReadSource;
import crawling.Utilities;
import crawling.entities.Announcement;
import crawling.entities.Period;
import crawling.entities.SearchInfo;
import crawling.*;

public abstract class XEAdvertisments{
	public static  Connection connection;
	
	public XEAdvertisments()
	{
		if(!openMySQLConnection()){
			System.out.println("FATAL ERROR!!!");
			System.exit(0);
		}
	}
	
	protected  boolean openMySQLConnection() {
		try {
				Class.forName("com.mysql.jdbc.Driver");
			Properties props = new Properties();
			props.put("user", "root");
			props.put("password", "");
			props.put("useUnicode", "true");
			props.put("characterEncoding", "utf-8");
			connection = DriverManager.getConnection(
					"jdbc:mysql://localhost:3306/temp09062009", props);
			/*connection = DriverManager.getConnection(
					"jdbc:mysql://localhost/temp09062009", props);*/
			return true;
			
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println("ERROR: Failed to get connection to database!");
			return false;
		}
	}

}
