/**
 * class AnnKeywords
 * @author Dimitra Xidara
 */
package crawling;

public final class AnnKeywords {
	
	/*********************************KEYWORDS FOR SECOND AREA*******************************************************/
	public final static String[] SECONDAREA_KEYWORDS = { "ðåñéï÷Þ", "èÝóç", "êïéíüôçôá",
		"äéüäéá", "ïéêéóìüò", "ýøïò", "÷ùñéü", "ìéêñÞ", "ðëçóßïí", "ïäüò",
		"ïñåéíÞ", "åèíéêÞ", "åßóïäïò", "üñéá", "êÝíôñï", "ÈÝóç", "åðß",
		"ðáëáéÜ","-","óõíïéêéóìüò","ðáñáëßá","Ýíáíôé","ëåùö.","üðéóèåí","óôÜóç","óýíïñá","ðëáôåßá","äßðëá",
		"ðåñéöåñåéáêüò"};
	
	public final static String EPI_THS_ODOY="åðß ôçò ïäïý";
	public final static String EPI_TWN_ODWN="åðß ôùí ïäþí";
	public final static String EPI_THS_LEWFOROY="åðß ôçò ëåùöüñïõ";
	
	public static final String PWLEITAI = "ÐÙËÅÉÔÁÉ - ";
	public static final String PWLEITAI1=" ÐÙËÅÉÔÁÉ - ";
	/********************************HOUSE TYPE**********************************************/
	public final static String DIAM="äéáì.";
	public final static String DIAMTA = "äéáì/ôá";
	public final static String DIAMTOS = "äéáì/ôïò";
	public final static String DIAMERISMA = "äéáìÝñéóìá";
	
	public final static String OROFODIAM = "ïñïöïäéáì.";
	public final static String OROFODIAMERISMA = "ïñïöïäéáìÝñéóìá";
	public final static String STUDIO_XWRIS = "óôïõíôéï";
	public final static String STUDIO = "óôïýíôéï";
	
	public final static String GARSONIERA = "ãêáñóïíéÝñá";
	public final static String GARSONIERAS = "ãêáñóïíéÝñáò";
	public final static String GARSONIERES = "ãêáñóïíéÝñåò";
	
	public final static String MEZONETA = "ìåæïíÝôá";
	public final static String MEZONETWN = "ìåæïíåôþí";
	public final static String MEZONETES = "ìåæïíÝôåò";
	public final static String MEZONETAS = "ìåæïíÝôáò";
	
	public final static String MONOKATOIKIA = "ìïíïêáôïéêßá";
	
	public final static String BILLA = "âßëá";
	public final static String BILA = "âßëëá";
	public final static String BILES = "âßëåò";
	
	public final static String RETIRE = "ñåôéñÝ";
	/********************************EARTH TYPE**********************************************/
	public final static String OIKOPXWRIS = "ïéêïð.";
	public final static String OIKOP = "ïéêüð.";
	public final static String OIKOPEDOY = "ïéêïðÝäïõ";
	public final static String OIKOPEDO = "ïéêüðåäï";
	public final static String OIKOPEDA = "ïéêüðåäá";
	public final static String OIKOPEDO_L = "ïéêïðåäü";
	
	public final static String AGROTEMAXEIO = "áãñïôåìÜ÷åéï";
	public final static String AGROTEMAXIA = "áãñïôåìÜ÷éá";
	public final static String AGROTEMAXIO = "áãñïôåìÜ÷éï";
	public final static String AGROTEMAXIO_XWRIS = "áãñïôåìá÷éï";
	
	public final static String AGROKTHMA = "áãñüêôçìá";
	public final static String AGROKTHMA_XWRIS = "áãñïêôçìá";
	public final static String AGROKTHMATA = "áãñïêôÞìáôá";
	
	public final static String AGROS = "áãñüò";
	
	public final static String AMPELI = "áìðÝëé";
	
	public final static String XWRAFI = "÷ùñÜöé";
	public final static String XWRAFIA = "÷ùñÜöéá";
/*********************************SIZE*******************************************************/
	public final static String STR = "óôñ.";
	public final static String STRSKETO = "óôñ";
	public final static String STREMMATA = "óôñÝììáôá";
	public final static String STREMMATWN = "óôñåììÜôùí";
	public final static String TM = "ô.ì.";
	public final static String TMSKETO = "ôì";
	public final static String ANA = "áíá";
	/*********************************IN MAP*******************************************************/
	public final static String ENTOS = "åíôüò";
	public final static String EKTOS = "åêôüò";
	public final static String SXEDIOY = "ó÷åäßïõ";
	/*********************************PRICE*******************************************************/
	public final static String TIMH = "ôéìÞ";
	public final static String EYRW = "åõñþ";
	public final static String E_GR = "å";
	public final static String E = "";
	public final static String SYMBOLO_EYRW="€";
	public final static String TIMH_EKKINHSHS="ÔéìÞ åêêßíçóçò:";
	public final static String TIMH_PLUS = "ÔéìÞ:";
	
	public final static String TIMH_PLUS2 = "ÔéìÞ:";
	
	public final static String ANA_XRONO = "/÷ñüí";
	public final static String ETHSIW = "åôçóßù";
	/*********************************BEDROOMS*******************************************************/
	public final static String YD = "õ/ä";
	public final static String YPNODWMATIA = "õðíïäùìÜôéá";
	public final static String ypnodwmatia="õðíïäùìáôéá";
	public final static String KREBATOKAMARES = "êñåâáôïêÜìáñåò";
	public final static String YPNO = "ýðíï";
	public final static String YPNOY = "ýðíïõ";
	public final static String YPN = "õðí.";
	public final static String YPD="õä";
	public final static String POSOSTO_SYNIDIOKTHSIAS="ìå ðïóïóôü óõíéäéïêôçóßáò åðß ôïõ ïéêïðÝäïõ åî áäéáéñÝôïõ";

	/*********************************FLOOR*******************************************************/
	public final static String OROFOS = "üñïöïò";
	
	public final static String OROFOY = "ïñüöïõ";
	
	public final static String OROFWN = "ïñüöùí";
	
	public final static String OS = "ïò";
	
	public final static String YPOGEIO = "õðüãåéï";
	
	public final static String ISOGEIO = "éóüãåéï";
	
	public final static String ISOGEIO_XWRIS = "éóïãåéï";
	
	public final static String ISOGEIO_ESTATE = "Éóüãåéï";
	
	public final static String HMIOROFOS = "çìéþñïöïò";
	
	public final static String HMIYPOGEIO = "çìéõðüãåéï";
	

	/*********************************AREAS*******************************************************/
	public final static String STEREA_ELLADA_BEYBOIA = "ÓôåñåÜ ÅëëÜäá & Â.Åýâïéá";

	public final static String NOMOS_ATTIKHS = "Íïìüò ÁôôéêÞò";
	
	public final static String NOMOS_THESSALONIKHS="Íïìüò Èåóóáëïíßêçò";
	
	public final static String THESSALONIKH = "ÈÅÓÓÁËÏÍÉÊÇ";
	
	public final static String PERIXWRA = "ÐÅÑÉ×ÙÑÁ";
	
	public final static String PERAIA = "ÐÅÑÁÉÁ";
	
	public final static String AG_PARASKEBHS = "ÁÃ.ÐÁÑÁÓÊÅÕÇÓ";
	
	public final static String MAKEDONIA = "ÌÁÊÅÄÏÍÉÁ";
	
	public final static String THRAKH = "èÑÁÊÇ";
	
	public final static String HPEIRO = "ÇÐÅÉÑÏ";
	
	public final static String THESSALIA = "èÅÓÓÁËÉÁ";

	public final static String ST_ELLADA = "ÓÔ.ÅËËÁÄÁ";
	
	public final static String ATTIKH = "ÁÔÔÉÊÇ";
	
	public final static String NHSIA = "ÍÇÓÉÁ";
	
	public final static String PELOPONNHSOS = "Ðåëïðüííçóïò";
	
	public final static String NOMOS_KORINTHIAS = "Íïìüò Êïñéíèßáò";
	
	public final static String YPOLOIPH_ELLADA = "ÕÐÏËÏÉÐÇ ÅËËÁÄÁ";
	
	public final static String ALLES_PERIOXES = "Áëëåò ðåñéï÷Ýò";
	
	public final static String MAKEDONIA_THRAKH = "ÌÁÊÅÄÏÍÉÁ-ÈÑÁÊÇ";
	
	public final static String HPEIRO_THESSALIA_STELLADA = "ÇÐÅÉÑÏ-ÈÅÓÓÁËÉÁ-ÓÔ.ÅËËÁÄÁ";
	
	public final static String EKTOS_ELLADAS = "ÅÊÔÏÓ ÅËËÁÄÁÓ";
	
	public final static String NHSIA_ARGOSARWNIKOY="ÍçóéÜ Áñãïóáñùíéêïý";
	
	public final static String SPORADES = "ÓðïñÜäåò";	
	/*********************************ADVERTISEMENTS TYPES CODES*******************************************************/
	public final static int SELL_EARTH_CODE = 697;

	public final static int RENT_HOUSE_CODE = 917;
	
	public final static int SELL_HOUSE_CODE = 256;
	
	public final static int AUCTION_CODE = 1365;
	
	public final static int EKSWXIKA_CODE=696;

	public final static int MAKEDONIA_ID = 5;
	public final static int THESSALONIKH_ID=2;
	public final static int STELLADA_BEYBOIA_ID= 9;
	public final static int ATTIKH_ID=1;
	public final static int THRAKH_ID = 3;
	public final static int HPEIRO_ID = 1;
	public final static int THESSALIA_ID =2;
	public final static int NHSIA_AIGAIOY_ID = 6;
	public final static int NHSIA_IONIOY_ID= 7;
	public final static int KRHTH_ID= 4;
	/*********************************ADVERTISEMENTS TYPES*******************************************************/
	public final static String ENOIKIASEIS_KATOIKIWN = "ÅíïéêéÜóåéò Êáôïéêéþí";
	
	public final static String PWLHSEIS_OIKOPEDWN = "ÐùëÞóåéò ÏéêïðÝäùí";
	
	public final static String PWLHSEIS_KATOIKIWN = "ÐùëÞóåéò Êáôïéêéþí";
	
	public final static String PLEISTHRIASMOI_AKINHTWN = "Ðëåéóôçñéáóìïß ÁêéíÞôùí";
	
	public final static String PWLHSEIS_EKSWXIKWN_KATOIKIWN = "ÐùëÞóåéò Åîï÷éêþí Êáôïéêéþí";
	
	public final static String ZHTHSH = "ÆÞôçóç";
	
	public final static String PWLHSEIS_KATOIKIWN_ZHTHSEIS = "ÐùëÞóåéò Êáôïéêéþí ÆçôÞóåéò";
	
	public final static String PWLHSEIS_OIKOPEDWN_KTHMATWN_ZHTHSEIS = "ÐùëÞóåéò ÏéêïðÝäùí ÊôçìÜôùí ÆçôÞóåéò";
	
	public final static String ENOIKIASEIS_KATOIKIWN_ZHTHSEIS = "ÅíïéêéÜóåéò Êáôïéêéþí ÆçôÞóåéò";
	/*********************************ADVERTISEMENTS SOURCES*******************************************************/
	public final static int XRYSH_EYKAIRIA = 1;
	public final static int AGGELIOXWROS = 2;
	public final static int ESTATE = 3;
	public final static int NEOMESITIKH = 4;
	public final static int KATHIMERINI = 5;
	
	/*********************************ENCODINGS*******************************************************/
	public final static String UTF8_ENCODING = "UTF-8";
	
	public final static String GREEK_ENCODING = "ISO-8859-7";
	
	public final static String WINDOWS_1253="windows-1253";
	/*************************************************************************************************/
	public final static String SOLD_KEYWORD ="SOLDIT.JPG";
	/*************************************WRONG AREAS*********************************************/

	public final static String THLEFWNO = "ÔçëÝöùíï";
	
	public final static String THL = "Ôçë.";
	
	public final static String THLEPIKOINWNIAS = "Ôçë.åðéêïéíùíßáò";
	
	public final static String THLMIKRO = "ôçë.";
	
	public final static String THL_ENG ="thl:";
	/********************************************************************************************/

	/*************************************WRONG AREAS*********************************************/
	public static String[] wrongWords = {"'ENOIKIAZONTAI'"
		,"'ÅÍÏÉÊÉÁÆÅÔÁÉ'","'ÐÙËÏÕÍÔÁÉ'","'ÐÙËÅÉÔÁÉ'",
		"'KOSMOS'","'FIAT'","'MEGA'","'PRACTIKER'","'TRANS'","'ÁÃÏÑÁÆÙ'","'ÁÊÉÍÇÔÁ'","'ÁÍÁÊÁÉÍÉÓÅÉÓ'",
		"'ÁÐÏ ÁÑ×ÉÔÅÊÔÏÍÁ'","'ÂÏÇÈÏÓ'","'ÄÉÁÌÅÑÉÓÌÁ'","'ÄÉÁÌÅÑÉÓÌÁÔÁ'","'ÊÁÉÍÏÕÑÃÉÏ'","'ÊÁÉÍÏÕÑÉÏ'",
		"'ÊÏÌÌÙÔÑÉÁÓ'","'ÊÔÇÌÁÔÏÌÅÓÉÔÉÊÇ'","'ÁÃÑÏÔÅÌÁ×ÉÁ'","'ÏÄÇÃÏÓ'","'ÏÉÊÏÅÐÅÍÄÕÓÇ'","'ÏÉÊÏÐÅÄÁ'",
		"'ÐÁÉÄÉÊÏ'","'ÑÅÔÉÑÅ'","'Ôå÷íéêÞ'","'YAMAHA'","'á)'","'ÁÑÔÏÆÁ×ÁÑÏÐËÁÓÔÅÉÏÕ'","'CITY'","'PEUGEOT'",
		"'ÃÊÁÑÓÏÍÉÅÑÁ'","'Â.'","'ÄÕÁÑÉ'","'ÈÅÁ ÓÔÇÍ'","''","'<hr'","'EÍÏÉÊÉÁÆÏÍÔÁÉ'","'ÆÇÔÏÕÍÔÁÉ'","'.'","'<img'",
		"'HONDA'","'ÏÐÉÓÈÅÍ'","'ÐÅÍÔÅ'","'ÐËÇÓÉÏÍ'","'ÁÃÏÑÁÆÏÕÌÅ'","'ÁÐÏÖÑÁÎÅÉÓ'",
		"'VW'","'TOYOTA'","'ÁÊÉÍÇÔÁ'","'ÁÍÅÎÁÑÔÇÔÅÓ'","'ÁÍÅÃÅÑÓÇ'","'ÃÑÁÖÅÉÏ'","'ÅÑÃÏËÁÂÏÓ'",
		"'ÅÑÃÏÓÔÁÓÉÁÊÏÓ'","'ÆÇÔÅÉÔÁÉ'","'æçôåß'","'ÇOME'","'ÊÔÇÌÁÔÏÌÅÓÉÔÉÊÇ'","'ÍÏÓÏÓÏÌÅÉÏ'","'ÐÙËÅÉÔÁÉ'","'ÐÙËÏÕÍÔÁÉ'",
		"'ÐÙË.'","'ÓÕÃÊÁÔÏÉÊÏÓ'","'ÖÙÔÏÔÕÐÅÉÏÕ'","''","'ÔÅ×ÍÉÊÇ'","'ÔÅ×ÍÉÊÇ ÅÔÁÉÑÅÉÁ'","'ÕÐ.'","'ÖÉË.'","'AUDI'","'ÅÎÁÉÑÅÔÉÊÏ'"
		,"'NISSAN'","'1'","'ÁÊÉÍÇÔÁ'","'ÓÅ ÓÕÃÊÑÏÔÇÌÁ'","'ÏÉÊÏÄÏÌÉÊÇ'","'ÁÃÑÏÔÅÌÁ×ÉÁ'","'ÁË.'","'ÁÍÔÁËËÁÊÔÉÊÁ'","'ÁÎÉÏËÏÃÏ'"
		,"'ÁÎÉÏËÏÃÏ'","'ÃÑÁÖÅÉÏ'","'ÅÐÉ ÏÉÊÏÐÅÄÏÕ'","'ÅÐÉÐËÁ'","'ÅÐÉ×ÅÉÑÇÓÇ'","'ÅÕÊÁÉÑÉÁ'","'ÉÓÏÃÅÉÏ'","'Ê.'","'ÊÁÔÁÓÊÅÕÁÓÔÉÊÏÓ'"
		,"'ÊÁÔÏÉÊÉÅÓ'","'Í.Ó.'","'ÔÁ'","'ÌÅÆÏÍÅÔÁ'","'ÌÅÆÏÍÅÔÅÓ'","'ÌÅÔÁÖÏÑÅÓ'","'ÓÔÏ ÍÅÏ'","'ÅÍÏÉÊÉÁÆÏÍÔÁÉ'","'ÄÙÄÅÊÁÏÑÏÖÅÓ'","'1) 860.000 ÅÕÑÙ'",
		"'CAFE SNACK BAR'","'7,5 ÁÐÏÄÏÓÇ'","'ÔÇËÅÏÐÔÉÊÏÓ ÓÔÁÈÌÏÓ'","'Á. ÊÁÍÁÊÉÄÇÓ & ÓÕÍÅÑÃÁÔÅÓ'",
		"'ÄÑÁÊÏÐÏÕËÏÕ ÍÏÑÁ'","'ÄÕÁÑÉ'","'ÁÃÏÑÁÆÏÕÌÅ'","'CRETAN'","'ÐÏËÕÔÅËÅÉÓ'","'-'","'ÏÉÊÏÄÏÌÉÊÅÓ'","'ÓÅ ÙÑÁÉÁ'",
		"'SDFSDS'","'85ÔÌ 2ÄÓÊÌÐ'","'CAFE SNACK BAR'","'CARREFOUR'","'ÔÁ'","''"};
	
	/*********************************FEATURE EXTRACTION KEYWORDS***************************************/
	public final static String DHMOS="ÄÞìïò";
	public final static String PERIOXH="Ðåñéï÷Þ";
	public final static String KATHGORIA_AKINHTOY="Êáôçãïñßá áêéíÞôïõ";
	public final static String TIMH_CAPS = "ÔéìÞ";
	public final static String TETR_METRA_OIKOPEDOY="Ôåôñ.ìÝôñá ïéêïðÝäïõ";
	public final static String TETR_METRA_AKINHTOY = "Ôåôñ. ìÝôñá áêéíÞôïõ";
	public final static String COORDINATOR_TYPE="Êáôçãïñßá óõíåñãÜôç";
	public final static String DIAKRITIKOS_TITLOS = "Äéáêñéôéêüò ôßôëïò";
	public final static String PERIGRAFH_ALLES_PLHR = "ÁíáëõôéêÞ ðåñéãñáöÞ";
	public final static String OROFOS_ESTATE = "¼ñïöïò";
	public final static String YPNODWMATIA_ESTATE = "ÕðíïäùìÜôéá";
	public final static String ONOMA="Ïíïìá";
	public final static String EPWNYMO="Åðþíõìï";
	public final static String XARAKTHRISTIKA_TOPOTHESIAS="×áñáêôçñéóôéêÜ ôïðïèåóßáò";
	public final static String HMIORWFOS_ESTATE = "Çìéüñïöïò";
	public final static String YPOGEIO_ESTATE = "Õðüãåéï";
	public final static String HMIYPOGEIO_ESTATE = "Çìéõðüãåéï";
	public final static String HMIISOGEIO_ESTATE = "Çìééóüãåéï";

	
	private AnnKeywords(){
		
	}

}
