package crawling;

import java.sql.Connection;
import java.sql.Date;
import java.sql.DriverManager;
import java.util.ArrayList;
import java.util.Properties;

import crawling.database.DatabaseChangeManager;
import crawling.database.DatabaseManager;
import crawling.database.DatabaseSelectManager;
import crawling.database.DatabaseUpdateManager;
import crawling.entities.AreaDescriptionEntity;
import crawling.entities.DoubleStringFormat;
import crawling.entities.HouseAnnouncement;
import crawling.entities.IdDescription;
import crawling.entities.MainArea;
import crawling.entities.Period;
import crawling.entities.PlotSellingAnnouncement;

public class Test {
	
	private Connection connection;
	
	public Test(){
		openMySQLConnection();
	}
	
	protected boolean openMySQLConnection() {
		try {
			Class.forName("com.mysql.jdbc.Driver");
			Properties props = new Properties();
			props.put("user", "root");
			props.put("password", "");
			props.put("useUnicode", "true");
			props.put("characterEncoding", "utf-8");
			connection = DriverManager.getConnection(
					"jdbc:mysql://localhost:3306/warehouse", props);
			return true;
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println("ERROR: Failed to get connection to database!");
			return false;
		}
	}
	
	public static void main(String[] args){
		Test test = new Test();
		PlotSellingAnnouncement plot = new PlotSellingAnnouncement();
//		plot.setCoo_id(null);
		plot.setEmbadon(new DoubleStringFormat(274.0));
//		plot.setInMap(null);
		plot.setMainAreaType(new IdDescription(198));
		plot.setOtherFeatures("ðùëåßôáé");
//		plot.setPrice(null);
		plot.setType(new IdDescription(1));
		plot.setSecArea("Ôñßãùíï");
				System.out.println("IS ALREADY IN:"+DatabaseManager.isEarthAnnAlreadyIn(1,1,plot,test.getConnection()));
//		Test test1 = new Test();
//		IdDescription cooTest = new IdDescription(1,"�������");
//		System.out.println("IS ALREADY IN:"+DatabaseManager.isPerioxhAlreadyIn(test1.getConnection(),cooTest));
//		ArrayList<MainArea> areas =DatabaseSelectManager.getAllKnownAreas(test1.getConnection());
//		for(MainArea area:areas){
//			System.out.println(area);
//		}
//		Date date = Date.valueOf("2006-06-26");
//		System.out.println("DATE:"+date);
//		Test test1= new Test();
//		HouseAnnouncement houseAnn1 = DatabaseSelectManager.getHouseAnnouncement(AnnKeywords.SELL_HOUSE_CODE,false,377589,test1.getConnection());
//		HouseAnnouncement houseAnn2 = DatabaseSelectManager.getHouseAnnouncement(AnnKeywords.SELL_HOUSE_CODE,false,414178,test1.getConnection());
//		System.out.println("EQUAL:"+HouseAnnouncement.equal(houseAnn1,houseAnn2));
//		System.out.println(houseAnn1);
//		System.out.println(houseAnn2);
//		ArrayList<IdDescription> anns = DatabaseSelectManager.getHouseAnnWithYpogeio(test1.getConnection());
//		System.out.println("RESULTS:"+anns.size());
//		ArrayList<IdDescription> diamerismata = DatabaseSelectManager.getDiamerismata(test1.getConnection());
//		for(IdDescription diam:diamerismata){
//			ArrayList<IdDescription> nomoi = DatabaseSelectManager.getNomoysOfDiamerismata(diam.getId(),test1.getConnection());
//			for(IdDescription nomos:nomoi){
////				ArrayList<IdDescription> dhmoi = DatabaseSelectManager.getPerioxhIdFromDhmosThatAreNull(nomos.getId(),test1.getConnection());
//				ArrayList<IdDescription> perioxes = DatabaseSelectManager.getPerioxesOfNomos(nomos.getId(),test1.getConnection());
//				for(IdDescription perioxh:perioxes){
//					int id=perioxh.getId();
//					String descr = perioxh.getDescription();
//					DatabaseChangeManager.changePerioxesTable(id,WordUtilities.turnIntoSuitableForm(descr),test1.getConnection());
//					
//				}
//				for(IdDescription dhmos:dhmoi){
//					int min=3;
//					int id = 0;
//					for(IdDescription perioxh:perioxes){
//						if(Utilities.findDistance(dhmos.getDescription(),perioxh.getDescription())<=min){
//							min=Utilities.findDistance(dhmos.getDescription(),perioxh.getDescription());
//							id= perioxh.getId();
//						}
//				}
//					if(id!=0){
//						DatabaseChangeManager.changeGeoDhmoiTable(dhmos.getId(),id,test1.getConnection());
//					}
//				}
				
				
			}
//		}
//		boolean equals = Utilities.findCommonRoot("�������","��������");
//		System.out.println("ARE EQUAL:"+equals);
//		String word1="�������";
//		String word2="�. ����������� ���������";
//	    word1=WordUtilities.turnInToTotalCaps(word1);
//	    System.out.println("WORD TO CAPS:"+word1);
//		System.out.println(word1.substring(3,word1.length()));
//		String javaVersion= System.getProperty("java.version");
//		System.out.println("JAVA VERSION:"+javaVersion);
//		ArrayList<Date> datesToChange = new ArrayList<Date>(5);
//		datesToChange.add(Date.valueOf(2006 + "-" + 3 + "-" + 2));
//		datesToChange.add(Date.valueOf(2006 + "-" + 3 + "-" + 12));
//		datesToChange.add(Date.valueOf(2006 + "-" + 3 + "-" + 1));
//		datesToChange.add(Date.valueOf(2006 + "-" + 3 + "-" + 5));
//		datesToChange.add(Date.valueOf(2006 + "-" + 2 + "-" + 5));
//		ArrayList<Date> sortedDates=Utilities.sortDates(datesToChange);
//		for(int i=0;i<sortedDates.size();i++){
//			System.out.println(i+" "+datesToChange.get(i));
//		}
//		ArrayList<Period> periods = new ArrayList<Period>(0);
//		for(int i=0;i<sortedDates.size()-1;i++){
//			periods.add(new Period(sortedDates.get(i),sortedDates.get(i+1)));
//		}
//		for(Period period:periods){
//			System.out.println(period);
//		}
////		DoubleStringFormat test1 = null;
////		DoubleStringFormat test2 = new DoubleStringFormat();
////		test2.setDoubleFormat(24.0);
////		System.out.println("IS EQUAL:"+DoubleStringFormat.equals(test1,test2));
//		PlotSellingAnnouncement plot1 = new PlotSellingAnnouncement();
//		plot1.setEmbadon(new DoubleStringFormat(35.0));
//		plot1.setInMap(null);
//		plot1.setMainAreaType(new IdDescription(1));
//		plot1.setOtherFeatures("���������, �����������������, ������, ������� ��������, �������, ������,    ");
//		plot1.setPrice(3500.0);
//		plot1.setSecArea(null);
//		plot1.setType(new IdDescription(0));
//		PlotSellingAnnouncement plot2 = new PlotSellingAnnouncement();
//		plot2.setEmbadon(new DoubleStringFormat(35.0));
//		plot2.setInMap(null);
//		plot2.setMainAreaType(new IdDescription(1));
//		plot2.setOtherFeatures("���������, �����������������, ������, ������� ��������, �������, �����");
//		plot2.setPrice(3500.0);
//		plot2.setSecArea(null);
//		plot2.setType(new IdDescription(0));
//		System.out.println("IS EQUAL:"+PlotSellingAnnouncement.equal(plot1,plot2));
//		ArrayList<String> test1 = new ArrayList<String>(0);
//		test1.add("TESTING 1");
//		test1.add("TESTING 2");
//		ArrayList<String> test2 = (ArrayList<String>)test1.clone();
//		test1.clear();
//		for(String test:test2){
//			System.out.println(test);
//		}
//		for(String test:test2){
//			System.out.println("THERE IS NO ENTRY:"+test);
//		}
//		String a="����";
//		String b = "������";
//		System.out.println("IS EQUAL:"+Utilities.isEqual(a,b));
//		String text2="28�� ���������";
//		String text1="28�� ���������";
//		boolean isEqual=false;
//		if (text1.equals(text2) || Utilities.findDistance(text1,text2)<=1 || text1.toUpperCase().equals(text2)
//				||text2.toUpperCase().equals(text1)
//				||Utilities.findDistance(text2.toUpperCase(),text1.toUpperCase())<=1) {
//			
//			isEqual=true;
//		}
//		System.out.println("Is equals:"+isEqual);
//		AreaDescriptionEntity area = new AreaDescriptionEntity();
//		area.setMainName("�������");
//		ArrayList<String> alterNames=new ArrayList<String>(0);
//		alterNames.add("�������");
//		alterNames.add("�������");
//		alterNames.add("������");
//		area.setAlterNames(alterNames);
//		System.out.print(area);
//	}

	public Connection getConnection() {
		return connection;
	}

	public void setConnection(Connection connection) {
		this.connection = connection;
	}

}
