package crawling.database;

import java.sql.Connection;
import java.sql.Date;
import java.sql.SQLException;
import java.sql.Statement;

public class DatabaseChangeManager {

	
	public static void changeDate(Date date,Integer id, Connection connection){
		Statement stmt = null;
		String query = "UPDATE ann_search_info SET DATE=\""+date+"\" WHERE SEARCHID="+id;
		try{
			stmt = connection.createStatement();
			stmt.executeUpdate(query);
		}catch(SQLException ex){
			System.out.println("ERROR:Error in changing ann_search_info");
			ex.printStackTrace();
		}
	}
	
	public static void changeNomosId(int id,int nomos_id,Connection connection){
		Statement stmt = null;
		String query = "UPDATE geo_perioxes SET NOMOS_ID="+nomos_id+" WHERE ID="+id;
		try{
			stmt = connection.createStatement();
			stmt.executeUpdate(query);
		}catch(SQLException ex){
			System.out.println("ERROR:Error in changing geo_perioxes");
			ex.printStackTrace();
		}
	}
	
	public static void changeGeoOdoiTable(int oldId,int newId,Connection connection){
		Statement stmt = null;
		String query = "UPDATE geo_odoi SET PERIOXH_ID="+newId+" WHERE PERIOXH_ID="+oldId;
		try{
			stmt = connection.createStatement();
			stmt.executeUpdate(query);
		}catch(SQLException ex){
			System.out.println("ERROR:Error in updating geo_odoi");
			ex.printStackTrace();
		}
	}
	
	public static void changeGeoDhmoiTable(int id,String description,Connection connection){
		Statement stmt = null;
		String query = "UPDATE geo_dhmoi_koinothtes SET DESCRIPTION='"+description+"' WHERE ID="+id;
		try{
			stmt = connection.createStatement();
			stmt.executeUpdate(query);
		}catch(SQLException ex){
			System.out.println("ERROR:Error in updating geo_dhmoi_koinothtes");
			ex.printStackTrace();
		}
	}
	public static void changePerioxesTable(int id,String description,Connection connection){
		Statement stmt = null;
		int irep=0;
		for(irep=0;irep<description.length();irep++)
		{
			if(description.substring(irep,irep+1).equals("'")==true)
			{
				description=description.replace("'","");
			}
				
		}
		String query = "UPDATE geo_perioxes SET DESCRIPTION='"+description+"' WHERE ID="+id;
		try{
			stmt = connection.createStatement();
			stmt.executeUpdate(query);
		}catch(SQLException ex){
			System.out.println("ERROR:Error in updating geo_perioxes");
			ex.printStackTrace();
		}
	}
	public static void changeGeoDhmoiTable(int id,int perioxh_id,Connection connection){
		Statement stmt = null;
		String query = "UPDATE geo_dhmoi_koinothtes SET PERIOXH_ID="+perioxh_id+" WHERE ID="+id;
		try{
			stmt = connection.createStatement();
			stmt.executeUpdate(query);
		}catch(SQLException ex){
			System.out.println("ERROR:Error in updating geo_dhmoi_koinothtes");
			ex.printStackTrace();
		}
	}
	public static void changeAnnHouseTable(int oldId,int newId,Connection connection){
		Statement stmt = null;
		String query = "UPDATE ann_house SET MAINAREA_ID="+newId+" WHERE MAINAREA_ID="+oldId;
		try{
			stmt = connection.createStatement();
			stmt.executeUpdate(query);
		}catch(SQLException ex){
			System.out.println("ERROR:Error in updating ann_house");
			ex.printStackTrace();
		}
	}
	public static void changeAnnHouseCooTable(int oldId,int newId,Connection connection){
		Statement stmt = null;
		String query = "UPDATE ann_house SET COO_ID="+newId+" WHERE COO_ID="+oldId;
		try{
			stmt = connection.createStatement();
			stmt.executeUpdate(query);
		}catch(SQLException ex){
			System.out.println("ERROR:Error in updating ann_house");
			ex.printStackTrace();
		}
	}
	public static void changeAnnSellEarthTable(int oldId,int newId,Connection connection){
		Statement stmt = null;
		String query = "UPDATE ann_sell_earth SET MAINAREA_ID="+newId+" WHERE MAINAREA_ID="+oldId;
		try{
			stmt = connection.createStatement();
			stmt.executeUpdate(query);
		}catch(SQLException ex){
			System.out.println("ERROR:Error in updating ann_sell_earth");
			ex.printStackTrace();
		}
	}
	public static void changeAnnSellEarthCooTable(int oldId,int newId,Connection connection){
		Statement stmt = null;
		String query = "UPDATE ann_sell_earth SET COO_ID="+newId+" WHERE COO_ID="+oldId;
		try{
			stmt = connection.createStatement();
			stmt.executeUpdate(query);
		}catch(SQLException ex){
			System.out.println("ERROR:Error in updating ann_sell_earth");
			ex.printStackTrace();
		}
	}
	public static void changeAnnAuctionTable(int oldId,int newId,Connection connection){
		Statement stmt = null;
		String query = "UPDATE ann_auction SET MAINAREA_ID="+newId+" WHERE MAINAREA_ID="+oldId;
		try{
			stmt = connection.createStatement();
			stmt.executeUpdate(query);
		}catch(SQLException ex){
			System.out.println("ERROR:Error in updating ann_auction");
			ex.printStackTrace();
		}
	}
	
	public static void changeGeoDhmoiKoinothtesTable(int oldId,int newId,Connection connection){
		Statement stmt = null;
		String query = "UPDATE geo_dhmoi_koinothtes SET PERIOXH_ID="+newId+" WHERE PERIOXH_ID="+oldId;
		try{
			stmt = connection.createStatement();
			stmt.executeUpdate(query);
		}catch(SQLException ex){
			System.out.println("ERROR:Error in updating geo_dhmoi_koinothtes");
			ex.printStackTrace();
		}
	}
	
	public static void changeFloor(int floor,int anid,Connection connection){
		Statement stmt = null;
		String query = "UPDATE ann_orofos SET OROFOS="+floor+" WHERE OROFOS=-1 AND ANID="+anid;
		try{
			stmt = connection.createStatement();
			int num=stmt.executeUpdate(query);
			System.out.println("RECORDS CHANGED:"+num);
		}catch(SQLException ex){
			System.out.println("ERROR:Error in updating ann_orofos");
			ex.printStackTrace();
		}
	}
}
