package crawling.databasecleaner;

import java.sql.Connection;
import java.sql.Date;
import java.sql.DriverManager;
import java.util.ArrayList;
import java.util.Properties;

import crawling.Utilities;
import crawling.database.DatabaseChangeManager;
import crawling.database.DatabaseSelectManager;

public class ChangeDates {
	
	private Connection warehouse15;
	private Connection warehouse22;
	private Connection warehouse;
	public static final Date newDate = Date.valueOf("2006-04-22");
	

	public ChangeDates() {
		if(openMySQLConnection()){
			correctDates();
		}
	}
	
	private boolean openMySQLConnection() {
		try {
			Class.forName("com.mysql.jdbc.Driver");
			Properties props = new Properties();
			props.put("user", "root");
			props.put("password", "");
			props.put("useUnicode", "true");
			props.put("characterEncoding", "utf-8");
			warehouse15 = DriverManager.getConnection(
					"jdbc:mysql://localhost:3306/temp18042008", props);
			warehouse22 = DriverManager.getConnection(
				"jdbc:mysql://localhost:3306/temp09062009", props);
			warehouse = DriverManager.getConnection("jdbc:mysql://localhost:3306/warehouse", props);

			return true;
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println("ERROR: Failed to get connection to database!");
			return false;
		}
	}
	
	private void correctDates(){
		ArrayList<Integer> ids15 = DatabaseSelectManager.getSearchIdS(warehouse15);
		ArrayList<Integer> ids22 = DatabaseSelectManager.getSearchIdS(warehouse22);
		ArrayList<Integer> ids29 = DatabaseSelectManager.getSearchIdS(warehouse);
		for(Integer id22:ids22){
			boolean found=false;
			for(Integer id15:ids15){
				if(Utilities.isEqual(id15,id22)){
					found=true;
					break;
				}
			}
			if(!found){
				DatabaseChangeManager.changeDate(Date.valueOf("2006-04-22"),id22,warehouse22);
			}
			
		}
		for(Integer id29:ids29){
			boolean found=false;
			for(Integer id22:ids22){
				if(Utilities.isEqual(id22,id29)){
					found=true;
					break;
				}
			}
			if(!found){
				DatabaseChangeManager.changeDate(Date.valueOf("2006-04-29"),id29,warehouse);
			}
		}
		
	}
	
	public static void main(String[] args){
		ChangeDates changeDates = new ChangeDates();
//		System.out.print(ChangeDates.newDate);
	}

}
