/**
 * Class Address
 * @author Dimitra Xidara
 */
package crawling.entities;

public class Address {

	private String street;
	private String number;
	private String postCode;
	private String city;
	private String nomos;
	
	public Address() {
	}

	public Address(String street, String number, String postCode, String city, String nomos) {
		this.street = street;
		this.number = number;
		this.postCode = postCode;
		this.city = city;
		this.nomos = nomos;
	}

	public String getCity() {
		return city;
	}

	public void setCity(String city) {
		this.city = city;
	}

	public String getNomos() {
		return nomos;
	}

	public void setNomos(String nomos) {
		this.nomos = nomos;
	}

	public String getNumber() {
		return number;
	}

	public void setNumber(String number) {
		this.number = number;
	}

	public String getPostCode() {
		return postCode;
	}

	public void setPostCode(String postCode) {
		this.postCode = postCode;
	}

	public String getStreet() {
		return street;
	}

	public void setStreet(String street) {
		this.street = street;
	}

	@Override
	public String toString() {
		return "street:"+street+" number:"+number+" postCode:"+postCode+" city:"+city+" nomos:"+nomos;
	}
	
	
}
