package crawling.entities;

import crawling.Utilities;

public class Auction {
	
	private int id;
	private IdDescription mainAreaType;
	private String secArea;
	private Double price;
	private String otherFeatures;
	private IdDescription type;
	private String percentage;
	
	
	public Auction() {
	}
	
	

	public Auction(int id) {
		this.id = id;
	}



	public Auction(int id, IdDescription mainAreaType, String secArea, Double price, String otherFeatures, IdDescription type, String percentage) {
		this.id = id;
		this.mainAreaType = mainAreaType;
		this.secArea = secArea;
		this.price = price;
		this.otherFeatures = otherFeatures;
		this.type = type;
		this.percentage = percentage;
	}
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}
	public IdDescription getMainAreaType() {
		return mainAreaType;
	}
	public void setMainAreaType(IdDescription mainAreaType) {
		this.mainAreaType = mainAreaType;
	}
	public String getOtherFeatures() {
		return otherFeatures;
	}
	public void setOtherFeatures(String otherFeatures) {
		this.otherFeatures = otherFeatures;
	}
	public String getPercentage() {
		return percentage;
	}
	public void setPercentage(String percentage) {
		this.percentage = percentage;
	}
	public Double getPrice() {
		return price;
	}
	public void setPrice(Double price) {
		this.price = price;
	}
	public String getSecArea() {
		return secArea;
	}
	public void setSecArea(String secArea) {
		this.secArea = secArea;
	}
	public IdDescription getType() {
		return type;
	}
	public void setType(IdDescription type) {
		this.type = type;
	}
	
	public static boolean isEqual(Auction auction1,Auction auction2){
		if(Utilities.isEqualOtherFeatures(auction1.getOtherFeatures(),auction2.getOtherFeatures())&& 
				auction1.getMainAreaType().getId()==auction2.getMainAreaType().getId()&&
				Utilities.isEqual(auction1.getSecArea(),auction2.getSecArea())&& 
				Utilities.isEqual(auction1.getPercentage(),auction2.getPercentage())&&
				IdDescription.equals(auction1.getType(),auction2.getType())&&
				Utilities.isEqual(auction1.getPrice(),auction2.getPrice())){	
			return true;
		}
		return false;
	}

}
