/**
 * class DoubleStringFormat
 * @author Dimitra Xidara
 */
package crawling.entities;

public class DoubleStringFormat {
	
	private String stringFormat;
	private Double doubleFormat;
	
	public DoubleStringFormat() {
	}

	
	public DoubleStringFormat(Double doubleFormat) {
		this.doubleFormat = doubleFormat;
	}


	public DoubleStringFormat(String stringFormat, Double doubleFormat) {
		this.stringFormat = stringFormat;
		this.doubleFormat = doubleFormat;
	}

	public Double getDoubleFormat() {
		return doubleFormat;
	}

	public void setDoubleFormat(Double integerFormat) {
		this.doubleFormat = integerFormat;
	}

	public String getStringFormat() {
		return stringFormat;
	}

	public void setStringFormat(String stringFormat) {
		this.stringFormat = stringFormat;
	}

	@Override
	public String toString() {
		return "DOUBLE FORMAT:"+doubleFormat+" STRING FORMAT:"+stringFormat;
	}
	
	public static boolean equals(DoubleStringFormat idDescr1,DoubleStringFormat idDescr2){
		if((idDescr1==null && idDescr2!=null) || (idDescr1!=null && idDescr2==null)){
			return false;
		}else if(idDescr1==null && idDescr2==null){
			return true;
		}else {
			if(idDescr2.getDoubleFormat().doubleValue() == idDescr1.getDoubleFormat().doubleValue()){
				return true;
			}
			return false;
		}
	}
	

}
